<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995-7 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>Chapter 23: Two-Dimensional (and Multidimensional) Arrays</title>
<link href="sx8.html" rev=precedes>
<link href="sx9a.html" rel=precedes>
<link href="top.html" rev=subdocument>
</head>
<body>
<H1>Chapter 23: Two-Dimensional (and Multidimensional) Arrays</H1>

<p>C does not have true multidimensional arrays.
However,
because of the generality of C's type system, you can have
<dfn>arrays of arrays</dfn>,
which are almost as good.
(This should not surprise you;
you can have arrays of anything, so why not arrays of arrays?)
</p><p>We'll use two-dimensional arrays as examples in this section,
although the techniques can
be extended to three or
more dimensions.
Here is a two-dimensional array:
<pre>
	int a2[5][7];
</pre>
Formally, <TT>a2</TT> is an array of 5 elements, each of which is
an array of 7 <TT>int</TT>s.
(We usually think of it as having 5 rows and 7 columns,
although this interpretation is not mandatory.)
</p><p>Just as we declared a two-dimensional array using two pairs of brackets,
we access its individual elements using two pairs of brackets:
<pre>
	int i, j;
	for(i = 0; i &lt; 5; i++)
		{
		for(j = 0; j &lt; 7; j++)
			a2[i][j] = 0;
		}
</pre>
Make sure that you remember to put each subscript in its own,
correct pair of brackets.
Neither
<pre>
	int a2[5, 7];		/* XXX WRONG */
</pre>
nor
<pre>
	a2[i, j] = 0;		/* XXX WRONG */
</pre>
nor
<pre>
	a2[j][i] = 0;		/* XXX WRONG */
</pre>
would do anything remotely like what you wanted.
</p><p><a href="sx9a.html" rel=subdocument>23.1: Multidimensional Arrays and Functions</a></p>
<p><a href="sx9b.html" rel=subdocument>23.2: Dynamically Allocating Multidimensional Arrays</a></p>
<hr>
<p>
Read sequentially:
<a href="sx8.html" rev=precedes>prev</a>
<a href="sx9a.html" rel=precedes>next</a>
<a href="top.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1996-1999
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
